searchData={"items":[{"type":"module","title":"Observer.Web","doc":"The entrypoint for defining your web interface, such\nas controllers, components, channels, and so on.","ref":"Observer.Web.html"},{"type":"macro","title":"Observer.Web.__using__/1","doc":"When used, dispatch to the appropriate controller/live_view/etc.","ref":"Observer.Web.html#__using__/1"},{"type":"function","title":"Observer.Web.html/0","doc":"","ref":"Observer.Web.html#html/0"},{"type":"function","title":"Observer.Web.live_component/0","doc":"","ref":"Observer.Web.html#live_component/0"},{"type":"function","title":"Observer.Web.live_view/0","doc":"","ref":"Observer.Web.html#live_view/0"},{"type":"module","title":"Observer.Web.Authentication","doc":"This module provides Authentication on mount","ref":"Observer.Web.Authentication.html"},{"type":"module","title":"References: - Observer.Web.Authentication","doc":"* https://github.com/oban-bg/oban_web/blob/main/lib/oban/web/authentication.ex","ref":"Observer.Web.Authentication.html#module-references"},{"type":"function","title":"Observer.Web.Authentication.on_mount/4","doc":"","ref":"Observer.Web.Authentication.html#on_mount/4"},{"type":"module","title":"Observer.Web.Components.Core","doc":"Provides core UI components.","ref":"Observer.Web.Components.Core.html"},{"type":"function","title":"Observer.Web.Components.Core.input/1","doc":"Renders an input with label and error messages.\n\nA `Phoenix.HTML.FormField` may be passed as argument,\nwhich is used to retrieve the input name, id, and values.\nOtherwise all attributes may be passed explicitly.","ref":"Observer.Web.Components.Core.html#input/1"},{"type":"function","title":"Types - Observer.Web.Components.Core.input/1","doc":"This function accepts all HTML input types, considering that:\n\n  * You may also set `type=\"select\"` to render a ` ` tag\n\n  * `type=\"checkbox\"` is used exclusively to render boolean values\n\n  * For live file uploads, see `Phoenix.Component.live_file_input/1`\n\nSee https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input\nfor more information. Unsupported types, such as hidden and radio,\nare best written directly in your templates.","ref":"Observer.Web.Components.Core.html#input/1-types"},{"type":"function","title":"Examples - Observer.Web.Components.Core.input/1","doc":"<.input field={@form[:email]} type=\"email\" />\n    <.input name=\"my-input\" errors={[\"oh no!\"]} />","ref":"Observer.Web.Components.Core.html#input/1-examples"},{"type":"function","title":"Attributes - Observer.Web.Components.Core.input/1","doc":"* `id` (`:any`) - Defaults to `nil`.\n* `name` (`:any`)\n* `label` (`:string`) - Defaults to `nil`.\n* `value` (`:any`)\n* `type` (`:string`) - Defaults to `\"text\"`.\n* `field` (`Phoenix.HTML.FormField`) - a form field struct retrieved from the form, for example: @form[:email].\n* `errors` (`:list`) - Defaults to `[]`.\n* `checked` (`:boolean`) - the checked flag for checkbox inputs.\n* `prompt` (`:string`) - the prompt for select inputs. Defaults to `nil`.\n* `options` (`:list`) - the options to pass to Phoenix.HTML.Form.options_for_select/2.\n* `multiple` (`:boolean`) - the multiple flag for select inputs. Defaults to `false`.\n* Global attributes are accepted. Supports all globals plus: `[\"accept\", \"autocomplete\", \"capture\", \"cols\", \"disabled\", \"form\", \"list\", \"max\", \"maxlength\", \"min\", \"minlength\", \"multiple\", \"pattern\", \"placeholder\", \"readonly\", \"required\", \"rows\", \"size\", \"step\"]`.","ref":"Observer.Web.Components.Core.html#input/1-attributes"},{"type":"function","title":"Slots - Observer.Web.Components.Core.input/1","doc":"* `inner_block`","ref":"Observer.Web.Components.Core.html#input/1-slots"},{"type":"function","title":"Observer.Web.Components.Core.label/1","doc":"Renders a label.","ref":"Observer.Web.Components.Core.html#label/1"},{"type":"function","title":"Attributes - Observer.Web.Components.Core.label/1","doc":"* `for` (`:string`) - Defaults to `nil`.","ref":"Observer.Web.Components.Core.html#label/1-attributes"},{"type":"function","title":"Slots - Observer.Web.Components.Core.label/1","doc":"* `inner_block` (required)","ref":"Observer.Web.Components.Core.html#label/1-slots"},{"type":"function","title":"Observer.Web.Components.Core.table_tracing/1","doc":"Renders a table with generic metric log styling.","ref":"Observer.Web.Components.Core.html#table_tracing/1"},{"type":"function","title":"Examples - Observer.Web.Components.Core.table_tracing/1","doc":"<.table_tracing id=\"users\" rows={@users}>\n      <:col :let={user} label=\"id\"><%= user.id %></:col>\n      <:col :let={user} label=\"username\"><%= user.username %></:col>\n    </.table_tracing>","ref":"Observer.Web.Components.Core.html#table_tracing/1-examples"},{"type":"function","title":"Attributes - Observer.Web.Components.Core.table_tracing/1","doc":"* `id` (`:string`) (required)\n* `rows` (`:list`) (required)\n* `row_id` (`:any`) - the function for generating the row id. Defaults to `nil`.\n* `row_click` (`:any`) - the function for handling phx-click on each row. Defaults to `nil`.\n* `transition` (`:boolean`) - Defaults to `false`.\n* `row_item` (`:any`) - the function for mapping each row before calling the :col and :action slots. Defaults to `&Function.identity/1`.","ref":"Observer.Web.Components.Core.html#table_tracing/1-attributes"},{"type":"function","title":"Slots - Observer.Web.Components.Core.table_tracing/1","doc":"* `col` (required) - Accepts attributes:\n\n  * `label` (`:string`)\n* `action` - the slot for showing user actions in the last table column.","ref":"Observer.Web.Components.Core.html#table_tracing/1-slots"},{"type":"module","title":"Observer.Web.Components.MultiSelectList","doc":"Multi select list box\n\nReferences:\n * https://www.creative-tim.com/twcomponents/component/multi-select","ref":"Observer.Web.Components.MultiSelectList.html"},{"type":"function","title":"Observer.Web.Components.MultiSelectList.bg_item_color/1","doc":"","ref":"Observer.Web.Components.MultiSelectList.html#bg_item_color/1"},{"type":"function","title":"Observer.Web.Components.MultiSelectList.border_item_color/1","doc":"","ref":"Observer.Web.Components.MultiSelectList.html#border_item_color/1"},{"type":"function","title":"Observer.Web.Components.MultiSelectList.content/1","doc":"","ref":"Observer.Web.Components.MultiSelectList.html#content/1"},{"type":"function","title":"Attributes - Observer.Web.Components.MultiSelectList.content/1","doc":"* `id` (`:string`) (required)\n* `selected_text` (`:string`) (required)\n* `selected` (`:list`) (required)\n* `unselected` (`:list`) (required)\n* `show_options` (`:boolean`) (required)","ref":"Observer.Web.Components.MultiSelectList.html#content/1-attributes"},{"type":"function","title":"Observer.Web.Components.MultiSelectList.text_item_color/1","doc":"","ref":"Observer.Web.Components.MultiSelectList.html#text_item_color/1"},{"type":"module","title":"Observer.Web.IndexLive","doc":"This module provides Observer context","ref":"Observer.Web.IndexLive.html"},{"type":"module","title":"References: - Observer.Web.IndexLive","doc":"* https://github.com/thiagoesteves/deployex/blob/main/lib/deployex_web/live/tracing/index.ex\n * https://github.com/oban-bg/oban_web/blob/main/lib/oban/web/dashboard_live.ex","ref":"Observer.Web.IndexLive.html#module-references"},{"type":"module","title":"Observer.Web.Layouts","doc":"This module provides layouts","ref":"Observer.Web.Layouts.html"},{"type":"module","title":"References: - Observer.Web.Layouts","doc":"* https://github.com/oban-bg/oban_web/blob/main/lib/oban/web/components/layouts.ex","ref":"Observer.Web.Layouts.html#module-references"},{"type":"function","title":"Observer.Web.Layouts.footer/1","doc":"","ref":"Observer.Web.Layouts.html#footer/1"},{"type":"function","title":"Observer.Web.Layouts.live/1","doc":"","ref":"Observer.Web.Layouts.html#live/1"},{"type":"function","title":"Observer.Web.Layouts.logo/1","doc":"","ref":"Observer.Web.Layouts.html#logo/1"},{"type":"function","title":"Observer.Web.Layouts.nav/1","doc":"","ref":"Observer.Web.Layouts.html#nav/1"},{"type":"function","title":"Observer.Web.Layouts.render/1","doc":"","ref":"Observer.Web.Layouts.html#render/1"},{"type":"function","title":"Observer.Web.Layouts.root/1","doc":"","ref":"Observer.Web.Layouts.html#root/1"},{"type":"module","title":"Observer.Web.ObserverPage","doc":"This is the live component responsible for handling the Observer page","ref":"Observer.Web.ObserverPage.html"},{"type":"behaviour","title":"Observer.Web.Resolver","doc":"Web customization is done through a callback module that implements the this behaviour.","ref":"Observer.Web.Resolver.html"},{"type":"behaviour","title":"Usage - Observer.Web.Resolver","doc":"Each callback is optional and resolution falls back to the default implementation when a\ncallback is omittied. Here is an example implementation that defines all callbacks with their\ndefault values for reference:\n\n```elixir\ndefmodule MyApp.Resolver do\n  @behaviour Observer.Web.Resolver\n\n  @impl true\n  def resolve_user(_conn), do: nil\n\n  @impl true\n  def resolve_access(_user), do: :all\nend\n```\n\nTo use a resolver such as `MyApp.Resolver` defined above, you pass it through as an option to\n`observer_dashboard/2` in your application's router:\n\n```elixir\nscope \"/\" do\n  pipe_through :browser\n\n  observer_dashboard \"/observer\", resolver: MyApp.Resolver\nend\n```","ref":"Observer.Web.Resolver.html#module-usage"},{"type":"behaviour","title":"Overview - Observer.Web.Resolver","doc":"Details about each callback's functionality can be found in the callback docs. Here's a quick\nsummary of each callback and its purpose:\n\n* [Current User](#c:resolve_user/1)—Extract the current user for access controls when the\ndashboard mounts.\n\n* [Action Controls](#c:resolve_access/1)—Restrict which operations users may perform or forbid\naccess to the dashboard.","ref":"Observer.Web.Resolver.html#module-overview"},{"type":"behaviour","title":"Authentication - Observer.Web.Resolver","doc":"By combining `resolver_user/1` and `resolve_access/1` callbacks it's possible to build an\nauthenticaiton solution around the dashboard. For example, this resolver extracts the\n`current_user` from the conn's assigns map and then scopes their access based on role. If it is\na standard user or `nil` then they're redirected to `/login` when the dashboard mounts.\n\n```elixir\ndefmodule MyApp.Resolver do\n  @behaviour Observer.Web.Resolver\n\n  @impl true\n  def resolve_user(conn) do\n    conn.assigns.current_user\n  end\n\n  @impl true\n  def resolve_access(user) do\n    case user do\n      %{admin?: true} -> :all\n      %{staff?: true} -> :read_only\n      _ -> {:forbidden, \"/login\"}\n    end\n  end\nend\n```","ref":"Observer.Web.Resolver.html#module-authentication"},{"type":"behaviour","title":"References: - Observer.Web.Resolver","doc":"* https://github.com/oban-bg/oban_web/blob/main/lib/oban/web/resolver.ex","ref":"Observer.Web.Resolver.html#module-references"},{"type":"type","title":"Observer.Web.Resolver.access/0","doc":"","ref":"Observer.Web.Resolver.html#t:access/0"},{"type":"callback","title":"Observer.Web.Resolver.resolve_access/1","doc":"Determine the appropriate access level for a user.\n\nDuring normal operation users can modify running queues and interact with jobs through the\ndashboard. In some situations actions such as pausing a queue may be undesired, or even\ndangerous for operations.\n\nThrough this callback you can tailor precisely which actions the current user can do. The\ndefault access level is `:all`, which permits _all_ users to do any action.\n\nReturning `{:forbidden, path}` prevents loading the dashboard entirely and redirects the user to\nthe provided path.\n\nThe available fine grained access controls are:\n\n* `:pause_queues`\n* `:scale_queues`\n* `:cancel_jobs`\n* `:delete_jobs`\n* `:retry_jobs`\n\nActions which aren't listed are considered disabled.","ref":"Observer.Web.Resolver.html#c:resolve_access/1"},{"type":"callback","title":"Examples - Observer.Web.Resolver.resolve_access/1","doc":"To set the dashboard read only and prevent users from performing any actions at all:\n\n    def resolve_access(_user), do: :read_only\n\nForbid any user that isn't an admin and redirect them to the root:\n\n    def resolve_access(user) do\n      if user.admin?, do: :all, else: {:forbidden, \"/\"}\n    end\n\nAlternatively, you can use the resolved `user` to allow admins write access and keep all other\nusers read only:\n\n    def resolve_access(user) do\n      if user.admin?, do: :all, else: :read_only\n    end\n\nYou can also specify fine grained access for each of the possible dashboard actions.\n\n    def resolve_access(user) do\n      if user.admin? do\n        [cancel_jobs: true, delete_jobs: true, retry_jobs: true]\n      else\n        :read_only\n      end\n    end","ref":"Observer.Web.Resolver.html#c:resolve_access/1-examples"},{"type":"callback","title":"Observer.Web.Resolver.resolve_user/1","doc":"Extract the current user from a `Plug.Conn` when the dashboard mounts.\n\nThe extracted user is passed to all of the other callback functions, allowing you to customize the\ndashboard per user or role.\n\nThis callback is expected to return `nil`, a map or a struct. However, the resolved user is only\npassed to other functions in the `Resolver` and as part of the metadata for audit events, so\nyou're free to use any data type you like.","ref":"Observer.Web.Resolver.html#c:resolve_user/1"},{"type":"callback","title":"Examples - Observer.Web.Resolver.resolve_user/1","doc":"Extract the user from the `assigns` map in a typical plug based auth setup:\n\n    def resolve_user(conn) do\n      conn.assigns.current_user\n    end","ref":"Observer.Web.Resolver.html#c:resolve_user/1-examples"},{"type":"type","title":"Observer.Web.Resolver.user/0","doc":"","ref":"Observer.Web.Resolver.html#t:user/0"},{"type":"module","title":"Observer.Web.Router","doc":"Provides mount points for the Web dashboard with customization.","ref":"Observer.Web.Router.html"},{"type":"module","title":"Customizing with a Resolver Callback Module - Observer.Web.Router","doc":"Implementing a `Observer.Web.Resolver` callback module allows you to customize the dashboard\nper-user, i.e. setting access controls.\n\nAs a simple example, let's define a module that makes the dashboard read only:\n\n```elixir\ndefmodule MyApp.Resolver do\n  @behaviour Observer.Web.Resolver\n\n  @impl true\n  def resolve_access(_user), do: :read_only\nend\n```\n\nThen specify `MyApp.Resolver` as your resolver:\n\n```elixir\nscope \"/\" do\n  pipe_through :browser\n\n  observer_dashboard \"/observer\", resolver: MyApp.Resolver\nend\n```\n\nSee the `Observer.Web.Resolver` docs for more details.","ref":"Observer.Web.Router.html#module-customizing-with-a-resolver-callback-module"},{"type":"module","title":"Running Multiple Dashboards - Observer.Web.Router","doc":"A single dashboard may connect to any number of running Observer instances. However, it's also\npossible to change the default instance via the `:observer_name` option. For example, given two\nconfigured Observer instances, `Observer` and `MyAdmin.Observer`, you can then mount both dashboards in your\nrouter:\n\n```elixir\nscope \"/\" do\n  pipe_through :browser\n\n  observer_dashboard \"/observer\", observer_name: Observer, as: :observer_dashboard\n  observer_dashboard \"/admin/observer\", observer_name: MyAdmin.Observer, as: :observer_admin_dashboard\nend\n```\n\nNote that the default name is `Observer` or the first found instance, setting `observer_name: Observer` in\nthe example above was purely for demonstration purposes.","ref":"Observer.Web.Router.html#module-running-multiple-dashboards"},{"type":"module","title":"On Mount Hooks - Observer.Web.Router","doc":"You can provide a list of hooks to attach to the dashboard's mount lifecycle. Additional hooks\nare prepended before [Observer Web's own Authentication](Observer.Web.Resolver). For example, to run a\nuser-fetching hook and an activation checking hook before mount:\n\n```elixir\nscope \"/\" do\n  pipe_through :browser\n\n  observer_dashboard \"/observer\", on_mount: [MyApp.UserHook, MyApp.ActivatedHook]\nend\n```","ref":"Observer.Web.Router.html#module-on-mount-hooks"},{"type":"module","title":"Customizing the Socket Connection - Observer.Web.Router","doc":"Applications that use a live socket other than \"/live\" can override the default socket path in\nthe router. For example, if your live socket is hosted at `/observer_live`:\n\n```elixir\nsocket \"/observer_live\", Phoenix.LiveView.Socket\n\nscope \"/\" do\n  pipe_through :browser\n\n  observer_dashboard \"/observer\", socket_path: \"/observer_live\"\nend\n```\n\nIf your application is hosted in an environment that doesn't support websockets you can use\nlongpolling as an alternate transport. To start, make sure that your live socket is configured\nfor longpolling:\n\n```elixir\nsocket \"/live\", Phoenix.LiveView.Socket,\n  longpoll: [connect_info: [session: @session_options], log: false]\n```\n\nThen specify \"longpoll\" as your transport:\n\n```elixir\nscope \"/\" do\n  pipe_through :browser\n\n  observer_dashboard \"/observer\", transport: \"longpoll\"\nend\n```","ref":"Observer.Web.Router.html#module-customizing-the-socket-connection"},{"type":"module","title":"Content Security Policy - Observer.Web.Router","doc":"To secure the dashboard, or comply with an existing CSP within your application, you can specify\nnonce keys for images, scripts and styles.\n\nYou'll configure the CSP nonce assign key in your router, where the dashboard is mounted. For\nexample, to use a single nonce for all three asset types:\n\n```elixir\nobserver_dashboard(\"/observer\", csp_nonce_assign_key: :my_csp_nonce)\n```\n\nThat instructs the dashboard to extract a generated nonce from the `assigns` map on the plug\nconnection, at the `:my_csp_nonce` key.\n\nInstead, you can specify different keys for each asset type:\n\n```elixir\nobserver_dashboard(\"/observer\",\n  csp_nonce_assign_key: %{\n    img: :img_csp_nonce,\n    style: :style_csp_nonce,\n    script: :script_csp_nonce\n  }\n)\n```","ref":"Observer.Web.Router.html#module-content-security-policy"},{"type":"macro","title":"Observer.Web.Router.observer_dashboard/2","doc":"Defines an observer dashboard route.\n\nIt requires a path where to mount the dashboard at and allows options to customize routing.","ref":"Observer.Web.Router.html#observer_dashboard/2"},{"type":"macro","title":"Options - Observer.Web.Router.observer_dashboard/2","doc":"* `:as` — override the route name; otherwise defaults to `:observer_dashboard`\n\n* `:on_mount` — declares additional module callbacks to be invoked when the dashboard mounts\n\n* `:observer_name` — name of the Observer instance the dashboard will use for configuration and\n  notifications, defaults to `Observer` or the first instance that can be found.\n\n* `:resolver` — an `Observer.Web.Resolver` implementation used to customize the dashboard's\n  functionality.\n\n* `:socket_path` — a phoenix socket path for live communication, defaults to `\"/live\"`.\n\n* `:transport` — a phoenix socket transport, either `\"websocket\"` or `\"longpoll\"`, defaults to\n  `\"websocket\"`.\n\n* `:csp_nonce_assign_key` — CSP (Content Security Policy) keys used to authenticate image,\n  style, and script assets by pulling a generated nonce out of the connection's `assigns` map. May\n  be `nil`, a single atom, or a map of atoms. Defaults to `nil`.","ref":"Observer.Web.Router.html#observer_dashboard/2-options"},{"type":"macro","title":"Examples - Observer.Web.Router.observer_dashboard/2","doc":"Mount an `observer` dashboard at the path \"/observer\":\n\n    defmodule MyAppWeb.Router do\n      use Phoenix.Router\n\n      import Observer.Web.Router\n\n      scope \"/\", MyAppWeb do\n        pipe_through [:browser]\n\n        observer_dashboard \"/observer\"\n      end\n    end","ref":"Observer.Web.Router.html#observer_dashboard/2-examples"},{"type":"macro","title":"References: - Observer.Web.Router.observer_dashboard/2","doc":"* https://github.com/oban-bg/oban_web/blob/main/lib/oban/web/router.ex","ref":"Observer.Web.Router.html#observer_dashboard/2-references"},{"type":"module","title":"Observer.Web.TracingPage","doc":"This is the live component responsible for handling the Tracing debug","ref":"Observer.Web.TracingPage.html"},{"type":"module","title":"ObserverWeb.Common","doc":"This module contains functions to be shared among other modules","ref":"ObserverWeb.Common.html"},{"type":"function","title":"ObserverWeb.Common.uuid4/0","doc":"Generates a random, version 4 UUID.\n\nCopied/Modified from https://github.com/elixir-ecto/ecto/blob/0746c94cc0a63c350732aa10ba661bcc0d9bd648/lib/ecto/uuid.ex#L190","ref":"ObserverWeb.Common.html#uuid4/0"},{"type":"function","title":"Examples - ObserverWeb.Common.uuid4/0","doc":"iex> alias Deployex.Common\n  ...> assert is_binary(Common.uuid4())\n  ...> assert is_binary(Common.uuid4())\n  ...> assert is_binary(Common.uuid4())\n  ...> assert is_binary(Common.uuid4())\n  ...> assert is_binary(Common.uuid4())","ref":"ObserverWeb.Common.html#uuid4/0-examples"},{"type":"module","title":"ObserverWeb.Rpc","doc":"This module will provide rpc abstraction","ref":"ObserverWeb.Rpc.html"},{"type":"function","title":"ObserverWeb.Rpc.call/5","doc":"Run the passed commands and link the process with the genserver calling\ngen_server for supervision","ref":"ObserverWeb.Rpc.html#call/5"},{"type":"behaviour","title":"ObserverWeb.Rpc.Adapter","doc":"Behaviour that defines Rpc handler","ref":"ObserverWeb.Rpc.Adapter.html"},{"type":"callback","title":"ObserverWeb.Rpc.Adapter.call/5","doc":"","ref":"ObserverWeb.Rpc.Adapter.html#c:call/5"},{"type":"module","title":"ObserverWeb.Rpc.Local","doc":"Local Rpc implementation","ref":"ObserverWeb.Rpc.Local.html"},{"type":"module","title":"ObserverWeb.Server","doc":"This server is responsible for handling tracing requests.\n\nInspired by:\n * https://www.erlang.org/docs/24/man/dbg\n * https://github.com/erlang/otp/blob/master/lib/observer/src/observer_trace_wx.erl\n * https://kaiwern.com/posts/2020/11/02/debugging-with-tracing-in-elixir/\n * https://blog.appsignal.com/2023/01/10/debugging-and-tracing-in-erlang.html\n * https://github.dev/massemanet/redbug","ref":"ObserverWeb.Server.html"},{"type":"function","title":"ObserverWeb.Server.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ObserverWeb.Server.html#child_spec/1"},{"type":"function","title":"ObserverWeb.Server.handle_trace/2","doc":"","ref":"ObserverWeb.Server.html#handle_trace/2"},{"type":"function","title":"ObserverWeb.Server.start_link/1","doc":"","ref":"ObserverWeb.Server.html#start_link/1"},{"type":"function","title":"ObserverWeb.Server.start_trace/2","doc":"","ref":"ObserverWeb.Server.html#start_trace/2"},{"type":"function","title":"ObserverWeb.Server.state/0","doc":"","ref":"ObserverWeb.Server.html#state/0"},{"type":"function","title":"ObserverWeb.Server.stop_trace/1","doc":"","ref":"ObserverWeb.Server.html#stop_trace/1"},{"type":"module","title":"ObserverWeb.Tracer","doc":"This module provides Tracer context","ref":"ObserverWeb.Tracer.html"},{"type":"module","title":"References: - ObserverWeb.Tracer","doc":"* https://github.com/thiagoesteves/deployex/blob/main/lib/deployex/tracer.ex","ref":"ObserverWeb.Tracer.html#module-references"},{"type":"function","title":"ObserverWeb.Tracer.get_default_functions_matchspecs/0","doc":"This function retrieves all match specs available","ref":"ObserverWeb.Tracer.html#get_default_functions_matchspecs/0"},{"type":"function","title":"ObserverWeb.Tracer.get_module_functions_info/2","doc":"This function retrieves all functions within the passed node and module","ref":"ObserverWeb.Tracer.html#get_module_functions_info/2"},{"type":"function","title":"ObserverWeb.Tracer.get_modules/1","doc":"This function retrieves all modules within the passed node","ref":"ObserverWeb.Tracer.html#get_modules/1"},{"type":"function","title":"ObserverWeb.Tracer.start_trace/2","doc":"This function starts the trace for the passed module/functions","ref":"ObserverWeb.Tracer.html#start_trace/2"},{"type":"function","title":"ObserverWeb.Tracer.state/0","doc":"This function returns the current trace server state","ref":"ObserverWeb.Tracer.html#state/0"},{"type":"function","title":"ObserverWeb.Tracer.stop_trace/1","doc":"This function stops the trace for the passed session ID","ref":"ObserverWeb.Tracer.html#stop_trace/1"},{"type":"type","title":"ObserverWeb.Tracer.t/0","doc":"","ref":"ObserverWeb.Tracer.html#t:t/0"},{"type":"extras","title":"Overview","doc":"# Overview\n\nObserver Web is an easy-to-use tool that integrates into your application to provide observability for processes, ports, and tracing using the [Erlang debugger][edb]. It supports running tracing and observer functionsfor both the local node and any other connected nodes. Powered by [Phoenix LiveView][liv], it is distributed, lightweight, and fully real-time. This library is part of the [DeployEx][dye] project.\n\n[dye]: https://github.com/thiagoesteves/deployex\n[edb]: https://www.erlang.org/doc/apps/runtime_tools/dbg.html\n[liv]: https://github.com/phoenixframework/phoenix_live_view","ref":"overview.html"},{"type":"extras","title":"Features - Overview","doc":"- **🐦‍🔥 Embedded LiveView** - Mount the dashboard directly in your application without any\n  external dependencies.\n\n- **🔍 Real Time Tracing** - Trace any function within your application, capturing parameters passed\nand also function callers, as many other possibilities.\n\n- **🔬 Process/Port Inspection** - View processes and ports details as well as their status and connectivity (and much more).","ref":"overview.html#features"},{"type":"extras","title":"Installation - Overview","doc":"See the [installation guide](installation.md) for details on installing and configuring Oban Web\nfor your application.","ref":"overview.html#installation"},{"type":"extras","title":"Installation","doc":"# Installation\n\nObserver Web is delivered as a hex package named `observer_web`. The package is entirely self contained—it\ndoesn't hook into your asset pipeline.","ref":"installation.html"},{"type":"extras","title":"Prerequisites - Installation","doc":"1. Ensure [Phoenix Live View][plv] is installed and working in your application. If you don't have\n   Live View, follow [these instructions][lvi] to get started.","ref":"installation.html#prerequisites"},{"type":"extras","title":"Configuration - Installation","doc":"Add `observer_web` as a dependency for your application. Open `mix.exs` and add the following line:\n\n```elixir\n{:observer_web, \"~> 0.1.0\"}\n```\n\nNow fetch your dependencies:\n\n```bash\nmix deps.get\n```\n\nThis will fetch `observer_web`.\n\nAfter fetching the package you'll use the `Observer.Web.Router` to mount the dashboard within your\napplication's `router.ex`:\n\n```elixir\n# lib/my_app_web/router.ex\nuse MyAppWeb, :router\n\nimport Observer.Web.Router\n\n...\n\nscope \"/\" do\n  pipe_through :browser\n\n  observer_dashboard \"/observer\"\nend\n```\n\nHere we're using `\"/observer\"` as the mount point, but it can be anywhere you like. See the\n`Observer.Web.Router` docs for additional options.\n\nAfter you've verified that the dashboard is loading you'll probably want to restrict access to the\ndashboard via authentication, either with a [custom resolver's][ac] access controls or [Basic\nAuth][ba].","ref":"installation.html#configuration"},{"type":"extras","title":"Usage with Web and Clustering - Installation","doc":"The Observer Web provides observer ability for the local application as well as any other that is\nclustered.","ref":"installation.html#usage-with-web-and-clustering"},{"type":"extras","title":"Customization - Installation","doc":"Web customization is done through the `Observer.Web.Resolver` behaviour. It allows you to enable\naccess controls. Using a custom resolver is entirely optional, but you should familiarize yourself\nwith the default limits and functionality.\n\nInstallation is complete and you're all set! Start your Phoenix server and enjoy erlang debugger!!!\n\n[plv]: https://github.com/phoenixframework/phoenix_live_view\n[lvi]: https://github.com/phoenixframework/phoenix_live_view#installation\n[ac]: Observer.Web.Resolver.html#c:resolve_access/1\n[ba]: https://hexdocs.pm/basic_auth/readme.html\n[oi]: installation.html","ref":"installation.html#customization"},{"type":"extras","title":"Changelog","doc":"# CHANGELOG (v0.1.0)","ref":"changelog.html"},{"type":"extras","title":"0.1.0 () - Changelog","doc":"","ref":"changelog.html#0-1-0"},{"type":"extras","title":"Backwards incompatible changes for 0.0.0 - Changelog","doc":"* None","ref":"changelog.html#backwards-incompatible-changes-for-0-0-0"},{"type":"extras","title":"Bug fixes - Changelog","doc":"* None","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Enhancements - Changelog","doc":"* None\n\n# Previous Releases\n * None","ref":"changelog.html#enhancements"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}